use crate::runtime::{
    Reference,
    acquire, release,
    type_key,
};
use crate::tag;
use super::varying;

pub struct Varying {
    managed:bool,
    addr:Reference,
}
impl Varying {
    pub fn new() -> Self
    {
        Self {
            managed:true,
            addr:unsafe {acquire(varying())},
        }
    }

    pub fn from(addr:Reference) -> Result<Self,()>
    {
        return if(unsafe {type_key(addr.class)} == tag::VARYING) {
            Ok(Self { managed:false, addr:addr })
        }
        else {
            Err(())
        }
    }

    pub fn set(&mut self, _addr:Reference)
    {
        
    }

    pub fn get(&self) -> Reference
    {
        self.addr
    }
}
impl std::ops::Deref for Varying {
    type Target = Reference;
    fn deref(&self) -> &Self::Target { return &self.addr; }
}
impl Drop for Varying {
    fn drop(&mut self) { if self.managed { unsafe {release(self.addr)}; } }
}
